IMPLEMENTATION MODULE FlyingLook;

(*
Implementation of Flying Look.

UK __DATE__ __TIME__
*)

(*IMP_SWITCHES*)
(*DRIVER*)

FROM AES        IMPORT Key,SpecialKey,KAlt,MouseButton,MBLeft,
                       ParmBlk,
                       BitBlk,BitBlkPtr,
                       ObjectState,Checked,Selected,Normal,Outlined,
                       ObjectFlags,ObjectFlag,
                       GText,GString,GTitle,GButton,GBox,GBoxText,GUserDef,
                       Root,Nil,
                       StringRange,String,StringPtr,
                       TreePtr,TreeIndex,ObjectIndex,ObjectPtr,
                       Small;
FROM EvntMgr    IMPORT Events,Event,MEvent,EvntEvent;
FROM ObjcMgr    IMPORT ObjcDraw,MaxDepth,ObjcFind,ObjcEdit,
                       EdStart,EdInit,EdChar,EdEnd;
FROM FormMgr    IMPORT FormError,NoMemory,FormKeybd,FormButton;
FROM GrafMgr    IMPORT GrafHandle,GrafDragBox;
FROM RsrcMgr    IMPORT RTree,RString,RsrcGAddr;
FROM WindMgr    IMPORT Desk;
FROM RcMgr      IMPORT GRect,GPnt;
FROM VDI        IMPORT XY,White,Black;
FROM VControl   IMPORT VSTLoadFonts,VSTUnloadFonts;
FROM VOutput    IMPORT VRRecFl,VPLine,VGText;
FROM VAttribute IMPORT VSLType,LTSolid,
                       VSLEnds,LESquared,VSLWidth,VSLColor,
                       VSWrMode,MdReplace,MdXOR,VSFColor,
                       VSFInterior,FISPattern,FISSolid,VSFStyle,
                       VSTEffects,TextEffect,Slanted,Underlined,
                       VSTHeight,VSTPoint,VSTFont;
FROM VRaster    IMPORT VRTCpyFm,MFDB;
FROM VQuery     IMPORT VQTAttributes,TextAttributes,VQTExtent,VQTFontInfo;
FROM VScreen    IMPORT VSound;
FROM AESTool    IMPORT NewObject,DisposeObject;
FROM ApplTool   IMPORT ApplGetInfo;
FROM ObjcTool   IMPORT EXCLObjectFlags,INCLObjectFlags,TreeWalk;
FROM FormTool   IMPORT Mask;
FROM GrafTool   IMPORT MouseForm,FlatHand,LastMouse;
FROM WindTool   IMPORT GetWorkXYWH,BeginUpdate,EndUpdate,
                       BeginMouseControl,EndMouseControl;
FROM RsrcTool   IMPORT TransformBitBlock,GetFreeImagePtr,SpecialChar,
                       NumberOfTrees,TreeArray;
FROM VDITool    IMPORT OpenVirtualWorkstation,CloseVirtualWorkstation,
                       SetClip,GRectToArray;
FROM PORTAB     IMPORT SIGNEDWORD,UNSIGNEDWORD,NULL;
FROM INTRINSIC  IMPORT PTR,VOID;
CAST_IMPORT

IMPORT AES,ApplMgr,FormMgr,RsrcMgr,GetObject,SetObject,FormTool,RsrcTool;

CONST Menu      = 14; (* GTitle  *)
      Separator = 15; (* GString *)
      Checker   = 16; (* GString *)

      Mover     = 17; (* GIBox   *)
      Button    = 18; (* GButton *)
      Title     = 19; (* GString *)
      Grouper   = 20; (* GButton *)
    (*          = 21;            *) (* Helper *)
      PopUp     = 22; (*         *)

(*    TheMenu      = 124;*)
      RadioButtons = 125;
      FlyingAlerts = 126;
      ScanCodes    = 127;

    (*Resvd128..Resvd255*)

VAR Handle   : UNSIGNEDWORD;

    AlertTree: TreePtr;

    RButNorm : BitBlkPtr; (* normal rounded radio button   *)
    RButSel  : BitBlkPtr; (* selected rounded radio button *)

    GrafCharWidth : UNSIGNEDWORD;
    GrafCharHeight: UNSIGNEDWORD; (* see TitleLine() *)
    GrafBoxWidth  : UNSIGNEDWORD;
    GrafBoxHeight : UNSIGNEDWORD;

    AESFontHeightIBM  : UNSIGNEDWORD;
    AESFontHeightSmall: UNSIGNEDWORD;
    AESFontIdIBM      : UNSIGNEDWORD;
    AESFontIdSmall    : UNSIGNEDWORD;
    AESFontTypeIBM    : UNSIGNEDWORD;
    AESFontTypeSmall  : UNSIGNEDWORD;
    Dummy             : UNSIGNEDWORD;

#if PCDOS || (GEMDOS && ABC)
    FirstCall: BOOLEAN;
#endif

PROCEDURE SetStateHiByte(Tree: TreePtr; Index: ObjectIndex; HiByte: StringRange);
BEGIN
#if not UNIX
  Tree^[Index].ObState:= Tree^[Index].ObState + CAST(ObjectState,VAL(UNSIGNEDWORD,HiByte * 256));
#else

#endif
END SetStateHiByte;

PROCEDURE GetStateHiByte(Tree: TreePtr; Index: ObjectIndex): StringRange;
BEGIN
#if not UNIX
  RETURN CAST(UNSIGNEDWORD,Tree^[Index].ObState) DIV 256;
#else

#endif
END GetStateHiByte;

PROCEDURE DrawBox(X,Y,W,H: XY);

VAR PXY: ARRAY[0..9] OF XY;

BEGIN
  PXY[0]:= X;
  PXY[1]:= Y;

  PXY[2]:= PXY[0];
  PXY[3]:= Y + H - 1;

  PXY[4]:= X + W - 1;
  PXY[5]:= PXY[3];

  PXY[6]:= PXY[4];
  PXY[7]:= PXY[1];

  PXY[8]:= PXY[0] + 1;
  PXY[9]:= PXY[1];

  VPLine(Handle,5,PXY);
END DrawBox;

PROCEDURE ShortCutText(PB    : ParmBlk;
                       Offset: SIGNEDWORD);

VAR Height     : UNSIGNEDWORD;
    CharWidth  : UNSIGNEDWORD;
    CharHeight : UNSIGNEDWORD;
    BoxWidth   : UNSIGNEDWORD;
    BoxHeight  : UNSIGNEDWORD;
    CurrAttr   : TextAttributes;
    Text       : StringPtr;
    ShortCutPos: StringRange;
    Str        : String;
    i          : StringRange;
    PXY        : ARRAY[0..7] OF XY;
    minADE     : UNSIGNEDWORD;
    maxADE     : UNSIGNEDWORD;
    Distances  : ARRAY[0..4] OF UNSIGNEDWORD;
    MaxWidth   : UNSIGNEDWORD;
    Effects    : ARRAY[0..2] OF UNSIGNEDWORD;

BEGIN
  WITH PB DO
    Text:= CAST(StringPtr,PBParm^.Parm);

    Height:= VSTHeight(Handle,AESFontHeightIBM,CharWidth,CharHeight,BoxWidth,BoxHeight);

    VQTExtent(Handle,Text^,PXY);

    IF (Offset = 0) THEN (* MenuTitle, ShortCutButton *)
      Offset:= (PBW - INT(PXY[2])) DIV 2;
    ELSE (* RadioButton, CheckBox *)
      Offset:= Offset + INT(CharWidth);
    END;

    VQTAttributes(Handle,CurrAttr);
    VQTFontInfo(Handle,minADE,maxADE,Distances,MaxWidth,Effects);

    VGText(Handle,
           PBX + Offset,
           PBY + (PBH - INT(CurrAttr.CellHeight)) DIV 2 + INT(Distances[4]),
           Text^);

    ShortCutPos:= GetStateHiByte(PBTree,PBObj);

    IF ShortCutPos > 0 THEN
      DEC(ShortCutPos);
      i:= 0;
      WHILE ShortCutPos > i DO
        Str[i]:= Text^[i];
        INC(i);
      END;
      Str[i]:= 0C;

      VQTExtent(Handle,Str,PXY); (* length of left string now in PXY[2] *)

      Str[0]:= Text^[ShortCutPos];
      Str[1]:= 0C;

      VSTEffects(Handle,TextEffect{Underlined});
      VGText(Handle,
             PBX + Offset + INT(PXY[2]),
             PBY + (PBH - INT(CurrAttr.CellHeight)) DIV 2 + INT(Distances[4]),
             Str);
      VSTEffects(Handle,TextEffect{});
    END;
  END;
END ShortCutText;

(***************************************************************************)

PROCEDURE MovingCorner(VAR PB: ParmBlk): ObjectState;

CONST Margin = 3; (* documented by Tim Oren *)

VAR Info: GetObject.ColorInfo;
    Rect: GRect;
    PXY : ARRAY[0..5] OF XY;

BEGIN
  WITH PB DO

    (* make the corner quadratic here if you like *)

    WITH Rect DO
      GX:= PBX - Margin;
      GY:= PBY - Margin;
      GW:= PBW + 2 * Margin;
      GH:= PBH + 2 * Margin;
    END;

    SetClip(Handle,Rect);

    GetObject.Color(PBTree,Root,Info);

    VSLColor(Handle,ORD(Info.InsideColor));
    DrawBox(PBX - 1,PBY - 2,PBW + 3,PBH + 3); (* draw white box *)

    VSLColor(Handle,ORD(Info.FrameColor)); (* black in b/w mode *)
    DrawBox(PBX - 2,PBY - 3,PBW + 5,PBH + 5); (* draw outlined *)
    DrawBox(PBX + 1,PBY,PBW - 1,PBH - 1);

    PXY[0]:= PBX - Margin + 1;
    PXY[1]:= PBY - Margin + 1;
    PXY[2]:= PBX + PBW + Margin - 1;
    PXY[3]:= PBY + PBH + Margin - 1;
    VPLine(Handle,2,PXY);

    RETURN Normal;
  END;
END MovingCorner;

PROCEDURE TitleLine(VAR PB: ParmBlk): ObjectState;

VAR Rect     : GRect;
    PXY      : ARRAY[0..7] OF XY;
    Extent   : UNSIGNEDWORD;
    Title    : StringPtr;
    minADE   : UNSIGNEDWORD;
    maxADE   : UNSIGNEDWORD;
    Distances: ARRAY[0..4] OF UNSIGNEDWORD;
    MaxWidth : UNSIGNEDWORD;
    Effects  : ARRAY[0..2] OF UNSIGNEDWORD;

BEGIN
  WITH PB DO
    Title:= CAST(StringPtr,PBParm^.Parm);
    VQTExtent(Handle,Title^,PXY);
    Extent:= PXY[2];

    WITH Rect DO
      GX:= PBX;
      GY:= PBY - 2;
      GW:= Extent;
      GH:= PBH + 4;
    END;

    SetClip(Handle,Rect);

    VQTFontInfo(Handle,minADE,maxADE,Distances,MaxWidth,Effects);

    IF GrafCharHeight >= 16 THEN
      VSLColor(Handle,Black); (* GStrings are always black *)
      PXY[0]:= PBX;
      PXY[1]:= PBY + INT(Distances[4] + Distances[0]) + 1;
      PXY[2]:= PBX + INT(Extent);
      PXY[3]:= PXY[1];
      VPLine(Handle,2,PXY);

      VGText(Handle,PBX,PBY + INT(Distances[4]),Title^);
    ELSE
      VSTEffects(Handle,TextEffect{Underlined});
      VGText(Handle,PBX,PBY + INT(Distances[4]),Title^);
      VSTEffects(Handle,TextEffect{});
    END;

    RETURN Normal;
  END;
END TitleLine;

PROCEDURE GroupBox(VAR PB: ParmBlk): ObjectState;

CONST Margin = 3; (* documented by Tim Oren *)

VAR Info      : GetObject.ColorInfo;
    Rect      : GRect;
    BoxSpec   : AES.ObjectSpec;
    Height    : UNSIGNEDWORD;
    CharWidth : UNSIGNEDWORD;
    CharHeight: UNSIGNEDWORD;
    BoxWidth  : UNSIGNEDWORD;
    BoxHeight : UNSIGNEDWORD;
    minADE    : UNSIGNEDWORD;
    maxADE    : UNSIGNEDWORD;
    Distances : ARRAY[0..4] OF UNSIGNEDWORD;
    MaxWidth  : UNSIGNEDWORD;
    Effects   : ARRAY[0..2] OF UNSIGNEDWORD;
    D         : UNSIGNEDWORD;

BEGIN
  Height:= VSTHeight(Handle,AESFontHeightIBM,CharWidth,CharHeight,BoxWidth,BoxHeight);

  WITH PB DO
    WITH Rect DO
      GX:= PBX ;
      GY:= PBY - INT(CharHeight);
      GW:= PBW;
      GH:= PBH + INT(CharHeight);
    END;

    SetClip(Handle,Rect);

    GetObject.Color(PBTree,Root,Info);
    VSLColor(Handle,ORD(Info.FrameColor));
    DrawBox(PBX,PBY,PBW,PBH);
(*  IF Shadowed IN GetObject.Flags(PBTree,PBObj) THEN

    END;*)
    BoxSpec.Address:= PBParm^.Parm;
(*  IF BoxSpec.TextInfo^.TEFont = Small THEN
      VSTHeight(Handle, ,D,D,D,D);
    END;*)
    VQTFontInfo(Handle,minADE,maxADE,Distances,MaxWidth,Effects); (* new height *)
    VGText(Handle,PBX + INT(GrafCharWidth),
                  PBY + INT(Distances[3]) DIV 2,
                  BoxSpec.TextInfo^.TEPText^);
(*  VSTHeight(Handle,CharHeight,D,D,D,D);*)
    RETURN Normal;
  END;
END GroupBox;

PROCEDURE CheckableItem(VAR PB: ParmBlk): ObjectState;

VAR Rect      : POINTER TO GRect;
    Item      : StringPtr;
    PXY       : ARRAY[0..3] OF XY;
    Height    : UNSIGNEDWORD;
    CharWidth : UNSIGNEDWORD;
    CharHeight: UNSIGNEDWORD;
    BoxWidth  : UNSIGNEDWORD;
    BoxHeight : UNSIGNEDWORD;
    minADE    : UNSIGNEDWORD;
    maxADE    : UNSIGNEDWORD;
    Distances : ARRAY[0..4] OF UNSIGNEDWORD;
    MaxWidth  : UNSIGNEDWORD;
    Effects   : ARRAY[0..2] OF UNSIGNEDWORD;

BEGIN
  WITH PB DO
    Rect:= PTR(PBX);
    SetClip(Handle,Rect^);

    Height:= VSTHeight(Handle,AESFontHeightIBM,CharWidth,CharHeight,BoxWidth,BoxHeight);

    VQTFontInfo(Handle,minADE,maxADE,Distances,MaxWidth,Effects);

    Item:= CAST(StringPtr,PBParm^.Parm);

    IF NOT (Selected IN (PBCurrState / PBPrevState)) THEN (* ObjcDraw() call *)
      VSTEffects(Handle,TextEffect{Slanted});
      VGText(Handle,PBX,PBY + INT(Distances[4]),Item^);
      VSTEffects(Handle,TextEffect{});
    ELSE                                                  (* ObjcChange() call *)
      VSFColor(Handle,Black);
      VSFInterior(Handle,FISSolid);
      Rect:= PTR(PBX);
      GRectToArray(Rect^,PXY);
      VSWrMode(Handle,MdXOR);
      VRRecFl(Handle,PXY);
      VSWrMode(Handle,MdReplace);
    END;

    RETURN PBCurrState - ObjectState{Selected};
  END;
END CheckableItem;

PROCEDURE MenuTitle(VAR PB: ParmBlk): ObjectState;

VAR Rect: GRect;
    PXY : ARRAY[0..3] OF XY;

BEGIN
  WITH PB DO
    WITH Rect DO
      GX:= PBX + 1;
      GY:= PBY + 1;
      GW:= PBW - 2;
      GH:= PBH - 2;
    END;

    SetClip(Handle,Rect);

    IF NOT (Selected IN (PBCurrState / PBPrevState)) THEN (* ObjcDraw() call *)
      ShortCutText(PB,0);
    ELSE                                                  (* ObjcChange() call *)
      VSFColor(Handle,Black);
      VSFInterior(Handle,FISSolid);
      GRectToArray(Rect,PXY);
      VSWrMode(Handle,MdXOR);
      VRRecFl(Handle,PXY);
      VSWrMode(Handle,MdReplace);
    END;

    RETURN PBCurrState - ObjectState{Selected};
  END;
END MenuTitle;

PROCEDURE ItemSeparator(VAR PB: ParmBlk): ObjectState;

VAR Rect: POINTER TO GRect;
    PXY : ARRAY[0..3] OF XY;

BEGIN
  WITH PB DO
    Rect:= PTR(PBX);
    SetClip(Handle,Rect^);

    VSFColor(Handle,Black); (* GStrings are always black *)
    VSFInterior(Handle,FISPattern);
    VSFStyle(Handle,4);
    PXY[0]:= PBX;
    PXY[1]:= PBY + PBH DIV 2;
    PXY[2]:= PBX + PBW - 1;
    PXY[3]:= PXY[1] + 1;
    VRRecFl(Handle,PXY);

    RETURN Normal;
  END;
END ItemSeparator;

PROCEDURE CheckBox(VAR PB: ParmBlk): ObjectState;

VAR Info : GetObject.ColorInfo;
    Rect : GRect;
    PXY  : ARRAY[0..9] OF XY;
    Width: SIGNEDWORD;

BEGIN
  WITH PB DO
    WITH Rect DO
      GX:= PBX;
      GY:= PBY;
      GW:= PBW + 3 * INT(GrafCharWidth);
      GH:= PBH + 2;
    END;
    SetClip(Handle,Rect);

    VSLType(Handle,LTSolid);
    VSLEnds(Handle,LESquared,LESquared);
    VSLWidth(Handle,1);
    GetObject.Color(PBTree,Root,Info);
    VSLColor(Handle,ORD(Info.FrameColor));
    VSWrMode(Handle,MdReplace);

    IF GrafBoxWidth >= 2 * GrafBoxHeight THEN
      Width:= 2 * PBH;
    ELSE
      Width:= PBH;
    END;

    IF NOT (Selected IN (PBCurrState / PBPrevState)) THEN (* ObjcDraw() call *)
      PXY[0]:= PBX;
      PXY[1]:= PBY;
      PXY[2]:= PBX + Width - 1;
      PXY[3]:= PBY;
      PXY[4]:= PXY[2];
      PXY[5]:= PBY + PBH - 1;
      PXY[6]:= PBX;
      PXY[7]:= PXY[5];
      PXY[8]:= PBX;
      PXY[9]:= PBY;
      VPLine(Handle,5,PXY);

      ShortCutText(PB,Width);
    END;

    IF Selected IN PBCurrState THEN (* ObjcChange() call *)
      VSLColor(Handle,ORD(Info.FrameColor));
    ELSE
      VSLColor(Handle,White);
    END;

    WITH Rect DO
      GX:= PBX + 1;
      GY:= PBY + 1;
      GW:= PBW - 2;
      GH:= PBH - 2;
    END;

    SetClip(Handle,Rect);

    PXY[0]:= PBX;
    PXY[1]:= PBY;
    PXY[2]:= PBX + Width - 1;
    PXY[3]:= PBY + PBH - 1;
    VPLine(Handle,2,PXY);

    PXY[0]:= PBX + Width - 1;
    PXY[1]:= PBY;
    PXY[2]:= PBX;
    PXY[3]:= PBY + PBH - 1;
    VPLine(Handle,2,PXY);

    RETURN PBCurrState - ObjectState{Selected};
  END;
END CheckBox;

PROCEDURE RadioButton(VAR PB: ParmBlk): ObjectState;

CONST BitsPerByte  = 8;
      BytesPerWord = 2;

VAR Rect  : GRect;
    Width : SIGNEDWORD;
    Src   : MFDB;
    Dst   : MFDB;
    PXY   : ARRAY[0..7] OF XY;
    BitImg: BitBlkPtr;

BEGIN
  WITH PB DO
    WITH Rect DO
      GX:= PBX;
      GY:= PBY - 1;
      GW:= PBW;
      GH:= PBH + INT(GrafBoxWidth) DIV 2 + 1; (* because of underlined text *)
    END;

    SetClip(Handle,Rect);

    IF GrafBoxWidth >= 2 * GrafBoxHeight THEN (* ATARI medium resolution *)
      Width:= 2 * RButNorm^.BIHL;
    ELSE
      Width:= RButNorm^.BIHL;
    END;

    IF Selected IN PBCurrState THEN
      BitImg:= RButSel;
    ELSE
      BitImg:= RButNorm;
    END;

    Dst.FDAddr:= NULL; (* destination:= screen *)

    WITH Src DO
      WITH BitImg^ DO
        FDAddr:= BIPData;
        FDW:= BIWB * BitsPerByte;
        FDH:= BIHL;
        FDWdWidth:= BIWB DIV BytesPerWord;
        FDStand:= FALSE;
        FDNPlanes:= 1;
      END;
    END;

    PXY[0]:= 0;
    PXY[1]:= 0;
    PXY[2]:= Src.FDW - 1;
    PXY[3]:= Src.FDH - 1;
    PXY[4]:= PBX;
    PXY[5]:= PBY + (PBH - INT(BitImg^.BIHL)) DIV 2; (* centered *)
    PXY[6]:= PXY[4] + PXY[2];
    PXY[7]:= PXY[5] + PXY[3];

    VRTCpyFm(Handle,MdReplace,PXY,Src,Dst,Black,White);

    ShortCutText(PB,Width); (* write text after raster copy *)

    RETURN PBCurrState - ObjectState{Selected};

  END;
END RadioButton;

PROCEDURE ShortCutButton(VAR PB: ParmBlk): ObjectState;

VAR Rect: GRect;
    PXY : ARRAY[0..3] OF XY;

BEGIN
  WITH PB DO
    WITH Rect DO
      GX:= PBX - 2;
      GY:= PBY - 4;
      GW:= PBW + 4;
      GH:= PBH + 8;
    END;

    SetClip(Handle,Rect);

    IF NOT (Selected IN (PBCurrState / PBPrevState)) THEN (* ObjcDraw() call  *)
      VSLColor(Handle,Black);
        DrawBox(PBX - 0,PBY - 2,PBW + 0,PBH + 4);
        DrawBox(PBX - 1,PBY - 3,PBW + 2,PBH + 6); (* always EXIT flag *)
      IF Default IN GetObject.Flags(PBTree,PBObj) THEN
        DrawBox(PBX - 2,PBY - 4,PBW + 4,PBH + 8);
      END;
      ShortCutText(PB,0);
    ELSE                                                  (* ObjcChange() call *)
      VSFColor(Handle,Black);
      VSFInterior(Handle,FISSolid);
      WITH Rect DO
        GX:= PBX + 1;
        GY:= PBY - 1;
        GW:= PBW - 2;
        GH:= PBH + 2;
      END;
      SetClip(Handle,Rect);
      GRectToArray(Rect,PXY);
      VSWrMode(Handle,MdXOR);
      VRRecFl(Handle,PXY);
      VSWrMode(Handle,MdReplace);
    END;

    RETURN PBCurrState - ObjectState{Selected};
  END;
END ShortCutButton;

(***************************************************************************)

  PROCEDURE install(Tree: TreePtr; Index: ObjectIndex): BOOLEAN;

    PROCEDURE MakeShortCut(Tree: TreePtr; Index: ObjectIndex);

    VAR ButtonStr  : StringPtr;
        ShortCutStr: String;
        i,j        : StringRange;

    BEGIN
      ButtonStr:= GetObject.StringPtr(Tree,Index);

      IF ButtonStr # NIL THEN
        i:= 0; j:= 0;
        WHILE ButtonStr^[i] # 0C DO
          IF ButtonStr^[i] = "[" THEN
            INC(i); (* first inc making hi byte > 0 *)
            SetStateHiByte(Tree,Index,i);
          ELSE
            ShortCutStr[j]:= ButtonStr^[i]; (* copy string *)
            INC(i); INC(j);
          END;
        END;

        ShortCutStr[j]:= 0C;
        SetObject.String(Tree,Index,ShortCutStr); (* replace object string *)
      END;
    END MakeShortCut;

  BEGIN
    CASE GetObject.Extnd(Tree,Index) OF
      Separator:
        (*
           assumption: the first separator (in the desk menu) has an
           extended object type.
        *)
#if PCDOS
        IF FirstCall THEN
#elif (GEMDOS && ABC)
#warning ...taking care of ABC-GEM
        IF FirstCall AND (AES.Version() = 0220H) THEN
#endif
#if PCDOS || (GEMDOS && ABC)
          FirstCall:= FALSE;
          RETURN TRUE; (* continue *)
        ELSE
#endif
          RETURN NewObject(Tree,Index,ItemSeparator,GetObject.StringPtr(Tree,Index));
#if PCDOS || (GEMDOS && ABC)
        END;
#endif
    | Button:
        MakeShortCut(Tree,Index);

        IF NOT(Exit IN GetObject.Flags(Tree,Index)) THEN
          IF RButton IN GetObject.Flags(Tree,Index) THEN
            (*
               take care of distances
             *)
            RETURN NewObject(Tree,Index,RadioButton,GetObject.StringPtr(Tree,Index));
          ELSE
            (*
               take care of distances
             *)
            RETURN NewObject(Tree,Index,CheckBox,GetObject.StringPtr(Tree,Index));
          END;
        ELSE
          RETURN NewObject(Tree,Index,ShortCutButton,GetObject.StringPtr(Tree,Index));
        END;
    | Mover:
#if (GEMDOS && ABC)
#warning ...taking care of ABC-GEM
        SetObject.State(Tree,Root,ObjectState{Outlined}); (* ...ABC-GEM *)
#endif
        RETURN NewObject(Tree,Index,MovingCorner,NIL);
    | Checker:
        RETURN NewObject(Tree,Index,CheckableItem,GetObject.StringPtr(Tree,Index));
    | Menu:
        MakeShortCut(Tree,Index);
        RETURN NewObject(Tree,Index,MenuTitle,GetObject.StringPtr(Tree,Index));
    | Title:
        RETURN NewObject(Tree,Index,TitleLine,GetObject.StringPtr(Tree,Index));
    | Grouper:
      (*CASE GetObject.Type(Tree,Index) OF
          GBoxText:*)
            RETURN NewObject(Tree,Index,GroupBox,GetObject.Spec(Tree,Index));
      (*| GButton: (* ? *)
            RETURN NewObject(Tree,Index,GroupButton,GetObject.Spec(Tree,Index));
        ELSE
          RETURN TRUE;  (* continue *)
        END;
      *)
    ELSE
      RETURN TRUE;
    END;

    RETURN TRUE;

  END install;

PROCEDURE Install(Tree: TreePtr);
BEGIN
  TreeWalk(Tree,Root,Nil,install);
END Install;

  PROCEDURE deinstall(Tree: TreePtr; Index: ObjectIndex): BOOLEAN;
  BEGIN
    CASE GetObject.Extnd(Tree,Index) OF
      Separator:
        DisposeObject(Tree,Index,GString);
    | Button:
        DisposeObject(Tree,Index,GButton);
    | Mover:
        DisposeObject(Tree,Index,GBox);
    | Checker:
        DisposeObject(Tree,Index,GString);
    | Title:
        DisposeObject(Tree,Index,GString);
    | Grouper:
        DisposeObject(Tree,Index,GBoxText);
    ELSE
      ;
    END;

    RETURN TRUE;

  END deinstall;

PROCEDURE Deinstall(Tree: TreePtr);
BEGIN
  TreeWalk(Tree,Root,Nil,deinstall);
END Deinstall;

(***************************************************************************)

PROCEDURE ApplInit(): SIGNEDWORD;

CONST MaxMemory = 32767; (* 512 kB (32768 * 16) *)
      FreeSpace = 4096;  (*  64 kB ( 4096 * 16) *)

VAR ApId : SIGNEDWORD;
    Fonts: UNSIGNEDWORD;

BEGIN
  ApId:= ApplMgr.applinit();

  IF ApId >= 0 THEN
    IF OpenVirtualWorkstation(Handle) THEN
      VOID(GrafHandle(GrafCharWidth,GrafCharHeight,GrafBoxWidth,GrafBoxHeight));

      ApplGetInfo(0,AESFontHeightIBM,AESFontIdIBM,AESFontTypeIBM,Dummy);
      ApplGetInfo(1,AESFontHeightSmall,AESFontIdSmall,AESFontTypeSmall,Dummy);

      Fonts:= VSTLoadFonts(Handle,0,MaxMemory,FreeSpace);
      VSTFont(Handle,AESFontIdIBM);

      RETURN ApId;
    ELSE
      FormError(NoMemory);
      ApplMgr.ApplExit;
      RETURN -1;
    END;
  END;

  RETURN ApId;
END ApplInit;

PROCEDURE ApplExit;
BEGIN
  VSTUnloadFonts(Handle,0);
  CloseVirtualWorkstation(Handle);
  ApplMgr.applexit;
END ApplExit;

(* new form_do() function **************************************************)

  VAR ShortCutChar: CHAR;
      ShortCutOb  : ObjectIndex;

  PROCEDURE searchshortcut(Tree: TreePtr; Index: ObjectIndex): BOOLEAN;

  VAR Str        : StringPtr;
      ShortCutPos: StringRange;
      Char       : CHAR;

  BEGIN
    IF GetObject.Extnd(Tree,Index) = Button THEN
      IF GetObject.Type(Tree,Index) = GUserDef THEN
#if not UNIX
        IF Indirect IN Tree^[Index].ObFlags THEN
          Str:= Tree^[Index].ObSpec.Extension^.Spec.UserBlock^.UBParm^.Parm;
        ELSE
          Str:= Tree^[Index].ObSpec.UserBlock^.UBParm^.Parm;
        END;
#else

#endif
        ShortCutPos:= GetStateHiByte(Tree,Index);
        IF ShortCutPos > 0 THEN
          Char:= Str^[ShortCutPos - 1];
          IF CAP(Char) = CAP(ShortCutChar) THEN
            ShortCutOb:= Index;
            RETURN FALSE; (* break *)
          END;
        END;
      END;
    END;
    RETURN TRUE; (* continue *)
  END searchshortcut;

PROCEDURE formdo(Tree : TreePtr;
                 Start: ObjectIndex): SIGNEDWORD;

CONST LastEdit = Flag15; (* flag for last edit position *)

TYPE Directions = (FmDDeflt,FmDForward,FmDBackward);

VAR Index   : StringRange;
    EditOb  : ObjectPtr;
    NextOb  : ObjectPtr;
    Cont    : BOOLEAN;
    EventRec: MEvent;
    MyEvent : Event;

  PROCEDURE FindObject(Tree   : TreePtr;
                       Start  : ObjectPtr;
                       Flag   : ObjectFlags;
                       Direct : Directions): ObjectIndex;

  VAR Index : ObjectPtr;
      ObFlag: ObjectFlag;
      I     : ObjectPtr;

  BEGIN
    Index:= Root;
    I:= 1;

    CASE Direct OF
      FmDBackward:
        I:= Nil;
        Index:= Start + I;
    | FmDForward:
        Index:= Start + I;
    | FmDDeflt:
        Flag:= Default;
    END;

    WHILE Index >= Root DO
      ObFlag:= GetObject.Flags(Tree,Index);
      IF Flag IN ObFlag THEN
        RETURN Index;
      END;
      IF LastOb IN ObFlag THEN
        Index:= Nil;
      ELSE
        Index:= Index + I;
      END;
    END;
    RETURN Start;
  END FindObject;

  PROCEDURE FirstObject(Tree : TreePtr;
                        Start: ObjectIndex): ObjectIndex;
  VAR Last: ObjectIndex;

  BEGIN
    IF Start = 0 THEN (* first look for last edit position *)
      Last:= FindObject(Tree,Root,LastEdit,FmDForward);
      IF Last = Root THEN
        RETURN FindObject(Tree,Root,Editable,FmDForward);
      ELSE
        RETURN Last;
      END;
    ELSE
      RETURN Start;
    END;
  END FirstObject;

BEGIN
  BeginMouseControl;

  NextOb:= FirstObject(Tree,Start);
  EditOb:= 0;
  Cont:= TRUE;

  WHILE Cont DO
    WITH EventRec DO
      IF (NextOb # Root) AND (EditOb # NextOb) THEN
        EditOb:= NextOb;
        NextOb:= Root;
        ObjcEdit(Tree,EditOb,EKR,Index,EdInit);
        EXCLObjectFlags(Tree,EditOb,LastEdit);
      END;

      EFlags:= Event{MuKeybd,MuButton};
      EBClk:= 2;
      EBMsk:= MouseButton{MBLeft};
      EBSt:= MouseButton{MBLeft};

      MyEvent:= EvntEvent(EventRec);

      IF MuKeybd IN MyEvent THEN
        Cont:= FormKeybd(Tree,EditOb,NextOb,EKR,NextOb,EKR);
        IF EKR.ScanCode # 0 THEN
          IF KAlt IN EKS THEN
            ShortCutOb:= Root;
            ShortCutChar:= SpecialChar(EKR);
            TreeWalk(Tree,Root,Nil,searchshortcut);
            Cont:= FormButton(Tree,ShortCutOb,1,NextOb); (* 1 click *)
          ELSE
            ObjcEdit(Tree,EditOb,EKR,Index,EdChar);
          END;
        END;
      END;

      IF MuButton IN MyEvent THEN
        NextOb:= ObjcFind(Tree,Root,MaxDepth,EMXY);
        IF NextOb = Nil THEN
          VSound(Handle,550,3); (* works fine with ABC-GEM and NVDI *)
          NextOb:= Root;
        ELSE
          Cont:= FormButton(Tree,NextOb,EBR,NextOb);
        END;
      END;

      IF (NOT Cont) OR ((NextOb # Root) AND (NextOb # EditOb)) THEN
        ObjcEdit(Tree,EditOb,EKR,Index,EdEnd);
      END;

    END;
  END;

  INCLObjectFlags(Tree,EditOb,LastEdit); (* mark last edit position *)

  EndMouseControl;

  RETURN NextOb;
END formdo;

PROCEDURE FormDo(Tree: TreePtr;
                 Start: ObjectIndex): SIGNEDWORD;

VAR Rect    : GRect;
    DeskRect: GRect;
    NewPos  : GPnt;
    Return  : SIGNEDWORD;
    ExitOb  : ObjectIndex;

BEGIN
  REPEAT
    Return:= formdo(Tree,Start); (* save return value *)
    ExitOb:= Mask(Return); (* remove double click *)
    IF GetObject.Extnd(Tree,ExitOb) = Mover THEN
      FormMgr.FormCenter(Tree,Rect);
      FormMgr.FormDial(FormMgr.FmDFinish,Rect,Rect);

      BeginUpdate;
      BeginMouseControl;

      GetWorkXYWH(Desk,DeskRect);

      MouseForm(FlatHand);
      GrafDragBox(Rect.GW,Rect.GH,Rect.GX,Rect.GY,DeskRect,NewPos);
      LastMouse;

      SetObject.X(Tree,Root,GetObject.X(Tree,Root) + NewPos.GX - Rect.GX);
      SetObject.Y(Tree,Root,GetObject.Y(Tree,Root) + NewPos.GY - Rect.GY);
      FormMgr.FormCenter(Tree,Rect);
      FormMgr.FormDial(FormMgr.FmDStart,Rect,Rect);
      ObjcDraw(Tree,Root,MaxDepth,Rect);

      EndMouseControl;
      EndUpdate;
    END;
  UNTIL GetObject.Extnd(Tree,ExitOb) # Mover;
  RETURN Return;
END FormDo;

(***************************************************************************)

PROCEDURE RsrcLoad(REF Name: ARRAY OF CHAR): BOOLEAN;

VAR Done      : BOOLEAN;
    Tree      : TreeIndex;
    RadioTree : TreePtr;
    Radio     : ObjectIndex;
    Height    : UNSIGNEDWORD;
    CharWidth : UNSIGNEDWORD;
    CharHeight: UNSIGNEDWORD;
    BoxWidth  : UNSIGNEDWORD;
    BoxHeight : UNSIGNEDWORD;
    CurrAttr  : TextAttributes;

BEGIN
  Done:= RsrcTool.RsrcLoad(Name); (* or: RsrcMgr.rsrcload(Name) *)

  RadioTree:= NULL;

  IF Done THEN (* scan whole resource for some extended object types *)
    FOR Tree:= 0 TO (NumberOfTrees() - 1) DO
      IF GetObject.Extnd(TreeArray(Tree),Root) = RadioButtons THEN
        RadioTree:= TreeArray(Tree);
      ELSIF GetObject.Extnd(TreeArray(Tree),Root) = FlyingAlerts THEN
        AlertTree:= TreeArray(Tree);
      END;

      Install(TreeArray(Tree));
    END;

    Height:= VSTHeight(Handle,AESFontHeightIBM,CharWidth,CharHeight,BoxWidth,BoxHeight);
    VQTAttributes(Handle,CurrAttr); (* query font height *)
    WITH CurrAttr DO
      IF CellHeight < 9 THEN (* minimum *)
        Radio:= 1;
      ELSIF CellHeight > 20 THEN (* maximum *)
        Radio:= 23;
      ELSE
        Radio:= 2 * (CellHeight - 9) + 1;
      END;

      IF (GrafBoxWidth >= 2 * GrafBoxHeight) THEN (* ATARI medium res. *)
        Radio:= 27; (* preliminary *)
      END;
    END;

#if not UNIX
    IF RadioTree # NULL THEN
      RButNorm:= RadioTree^[Radio].ObSpec.BitBlock;
      RButSel:= RadioTree^[Radio + 1].ObSpec.BitBlock;
    END;
#else

#endif
  END;
  RETURN Done;
END RsrcLoad;

PROCEDURE RsrcFree;

VAR Tree: TreeIndex;

BEGIN
(*
  FOR Tree:= 0 TO (NumberOfTrees() - 1) DO
    Deinstall(TreeArray(Tree));
  END;
*)
  RsrcMgr.rsrcfree;
END RsrcFree;

(* new form_alert() function ***********************************************)

(*
PROCEDURE FlyingAlert(DefBut  : UNSIGNEDWORD;
                      PAlrtStr: ANYPOINTER): UNSIGNEDWORD;
BEGIN

END FlyingAlert;
*)

BEGIN
  ApplMgr.ApplInit:= ApplInit;
  ApplMgr.ApplExit:= ApplExit;

  FormMgr.FormDo:= FormDo;
  FormMgr.FormDial:= FormTool.FormDial;
  FormMgr.FormCenter:= FormTool.FormCenter;
(*FormMgr.FormAlert:= FlyingAlert;*)

  RsrcMgr.RsrcLoad:= RsrcLoad;
  RsrcMgr.RsrcFree:= RsrcFree;

#if PCDOS || (GEMDOS && ABC)
  FirstCall:= TRUE;
#endif
END FlyingLook.
